' Which DAC Register Is Used for each Attribute
FUNCTION WhichRegister%(BYVAL Register%)

  ASM mov ax, &H1007       ; function 10h, subfunction 07h
  ASM mov bl, Register%    ; register to check
  ASM int &H10             ; call BIOS services
  ASM mov FUNCTION, bh     ; set return value of function

END FUNCTION

' Read DAC Register Settings
SUB ReadDACRegister(BYVAL Register%, Red?, Green?, Blue?)

  ASM push si              ; store the SI register
  ASM mov ax, &H1015       ; function 10h, subfunction 15h
  ASM mov bl, Register%    ; the register to check
  ASM int &H10             ; call BIOS services
  ASM les si, Red?         ; get a pointer to Red?
  ASM mov es:[si], dh      ; copy the red value
  ASM les si, Green?       ; get a pointer to Green?
  ASM mov es:[si], ch      ; copy the green value
  ASM les si, Blue?        ; get a pointer to Blue?
  ASM mov es:[si], cl      ; copy the blue value
  ASM pop si               ; restore the SI register

END SUB

' Set DAC Register Colors
SUB SetDACRegister(BYVAL Register%, BYVAL Red?, BYVAL Green?, BYVAL Blue?)

  ASM mov ax, &H1010       ; function 10h, subfunction 10h
  ASM mov bx, Register%    ; register to change
  ASM mov dh, Red?         ; new red value
  ASM mov ch, Green?       ; new green value
  ASM mov cl, Blue?        ; new blue value
  ASM int &H10             ; call BIOS services

END SUB
